'use strict';

const { CrudService } = require('naf-framework-mongoose/lib/service');
const uuid = require('uuid');
const moment = require('moment');
const assert = require('assert');
class OrderService extends CrudService {
  constructor(ctx) {
    super(ctx, 'order');
    this.model = this.ctx.model.Order;
  }
  async create({ name, phone, openid, code, hospitalId, hospitalName, subjectId, subjectName, status, remark, code1 }) {
    assert(name, '请填写完整信息');
    assert(phone, '请填写完整信息');
    assert(openid, '请填写完整信息');
    assert(code, '请填写完整信息');
    assert(hospitalId, '请填写完整信息');
    assert(hospitalName, '请填写完整信息');
    assert(subjectId, '请填写完整信息');
    assert(subjectName, '请填写完整信息');
    const time = moment().format('YYYY-MM-DD HH:mm:ss');
    let out_trade_no = uuid.v1();
    out_trade_no = out_trade_no.replace(/-/g, '');
    const res = await this.model.create({ name, phone, openid, time, code, hospitalId, hospitalName, subjectId, subjectName, status, remark, out_trade_no, code1 });
    return res;
  }
  async updatestatus({ out_trade_no, status }) {
    assert(out_trade_no, '缺少参数out_trade_no');
    const res = await this.model.findOne({ out_trade_no }).updateOne({ status });
    return res;
  }
}

module.exports = OrderService;
