'use strict';

const ErrorConfig = require('./config.error.js');

module.exports = appInfo => {
  const config = exports = {};

  // use for cookie sign key, should change to your own and keep security
  config.keys = appInfo.name + '_1512517259953_9547';

  // add your config here
  config.middleware = [];

  // 安全配置
  config.security = {
    csrf: {
      // ignoreJSON: true, // 默认为 false，当设置为 true 时，将会放过所有 content-type 为 `application/json` 的请求
      enable: false,
    },
  };
  // server config
  config.cluster = {
    listen: {
      port: 9001,
    },
  };
  config.wxapi = {
    // 微信公众号APPID
    appid: 'wx3ce04cdc39e157c7',
    // 微信网关地址
    baseUrl: 'http://wx.cc-lotus.info',
    // 获取微信token地址
    tokenUrl: 'https://api.weixin.qq.com/cgi-bin/token',
    // 密钥
    appsecret: 'ea08dc7bf4a1af94de364037d088d386',
    // 模板消息请求地址
    mould: 'https://api.weixin.qq.com/cgi-bin/message/template/send',
    // 管理员消息模板（派单模板）
    adminTemplateId: 'ZocrG3JPgbhEzgdJZwh4mkPUZBly9ebmVi1vbqCWrGw',
    // 用户消息模板
    userTemplateId: 'uBv5J9ZVroBO5hFf1pMhE-wgqHWsecLgqBRctfHzNog',
    // 直连商户号
    mchid: '1615207497',
    // 证书序列号
    certid: '40B12C961A549B4A5FE8E6953035011C0DCAEF97',
    // 私钥开发
    // wxKey: 'D:/wxcert/apiclient_key.pem',
    // 发布
    wxKey: '/home/medical/wxcert/apiclient_key.pem',
    // 证书
    // wxcert: 'D:/wxcert/apiclient_cert.pem',
    v3key: '95a2d13030a711eca32bf1859288b55d',
  };
  config.jwt = {
    secret: 'Ziyouyanfa!@#',
    expiresIn: '2h',
    issuer: 'platform',
  };

  config.onerror = ErrorConfig;

  // mongoose config
  config.mongoose = {
    url: 'mongodb://127.0.0.1:27018/jzyl',
    options: {
      user: 'root',
      pass: 'cms@cc-lotus',
      authSource: 'admin',
      useNewUrlParser: true,
      useCreateIndex: true,
    },
  };

  // mq config
  config.amqp = {
    client: {
      hostname: '127.0.0.1',
      username: 'smart',
      password: 'smart123',
      vhost: 'smart',
    },
    app: true,
    agent: true,
  };

  // redis config
  config.redis = {
    client: {
      port: 6379, // Redis port
      host: '127.0.0.1', // Redis host
      password: null,
      db: 0,
    },
  };

  config.view = {
    defaultViewEngine: 'nunjucks',
    mapping: {
      '.njk': 'nunjucks',
    },
  };

  // 加载 errorHandler 中间件
  // config.middleware = [ 'errorHandler' ];
  // 只对 /api 前缀的 url 路径生效
  // config.errorHandler = {
  //   match: '/api',
  // };

  return config;
};
